﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.LoadTesting;

namespace PluginLib
{
    public class LoadtestContextCopy : ILoadTestPlugin
    {
        // Summary:
        //     Initializes the load test plug-in.
        //
        // Parameters:
        //   loadTest:
        //     The load test to be executed.

        LoadTest m_loadTest;

        public void Initialize(LoadTest loadTest)
        {
            m_loadTest = loadTest;
            m_loadTest.TestStarting += new EventHandler<TestStartingEventArgs>(loadTestStarting);
        }

        void loadTestStarting(object sender, TestStartingEventArgs e)
        {
            foreach (string key in m_loadTest.Context.Keys)
            {
                e.TestContextProperties.Add(key, m_loadTest.Context[key]);
            }
        }
    }
}
